﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinTree;

namespace _113608
{
    class RemoveExpand:IUIElementCreationFilter 
    {
        private List<Infragistics.Win.UltraWinTree.UltraTreeNode> list;

        public List<Infragistics.Win.UltraWinTree.UltraTreeNode> List
        {
            get { return list; }
            
        }

        public RemoveExpand(List<Infragistics.Win.UltraWinTree.UltraTreeNode> list)
        {
            // TODO: Complete member initialization
            this.list = list;
        }

        public void AfterCreateChildElements(UIElement parent)
        {
            
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            if (parent is Infragistics.Win.UltraWinTree.ExpansionIndicatorUIElement)
            {
                UltraTreeNode node = ((TreeNodeUIElement)parent.GetAncestor (typeof(TreeNodeUIElement))).Node ;
                bool result = this.list.Contains(node);
                if (result)
                {
                    NodeConnectorUIElement line = new NodeConnectorUIElement(parent.Parent);
                    line.Rect = parent.Rect;
                    parent.Parent.ChildElements.Add(line);
                    parent.Parent.ChildElements.Remove(parent);
                }
                   
                return result;
            }

                return false;
        }
    }
}
